com.ihr.xbrl.om.table.definition

## Class XBRLDimensionRelationshipNode

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLPointerOfARelationship
      - - com.ihr.xbrl.om.exLinks.XBRLResource
        - - com.ihr.xbrl.om.table.XBRLTableResource
          - - com.ihr.xbrl.om.table.definition.XBRLDefinitionNode
            - - com.ihr.xbrl.om.table.definition.XBRLClosedDefinitionNode
              - - com.ihr.xbrl.om.table.definition.XBRLRelationshipNode
                - - com.ihr.xbrl.om.table.definition.XBRLDimensionRelationshipNode

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLRelationshipPoint, HasBreakdownTree, HasParentChildAttribute, HasTableProcessor, StaticCheck, Thinable, XBRLValidation, XBRLValueKey, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class XBRLDimensionRelationshipNode
      extends XBRLRelationshipNode

  The Class XBRLDimensionRelationshipNode.
  Author:
    Ignacio

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `XBRLDimensionRelationshipNode.Node` The Class Node.

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.table.HasParentChildAttribute

      `HasParentChildAttribute.ParentChildEnum`

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    - ### Fields inherited from class com.ihr.xbrl.om.table.definition.XBRLDefinitionNode

      `tagSelector`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `log, nullResource`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

    - ### Fields inherited from interface com.ihr.xbrl.om.table.HasParentChildAttribute

      `parentChilOrder`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLDimensionRelationshipNode(XBRLTableProcessor xbrlTableProcessor, XBRLResource res)` Instantiates a new XBRL dimension relationship node.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `javax.xml.namespace.QName` | `getDimension()` Access to the dimension QName for this node.
    `int` | `getGenerations(XBRLStructuralTable xbrlTable, RC_XFI_concept_relationshipsBase.Axis axis)` Access to the resolved generations parameter
    `javax.xml.namespace.QName[]` | `getSources(XBRLStructuralTable xbrlTable)` Access to the resolved QName sources.
    `boolean` | `isAbstract()` Returns true if this is a closed definition node and is abstract.
    `XBRLStructuralNode[]` | `readDefinitionNodeSubTree(XBRLDefinitionNodeUse dnu, XBRLStructuralTable xbrlTable, java.util.Hashtable<java.lang.String,java.util.Hashtable<java.lang.Object,AspectAndDistanceToLeaf>> mergeAspects, java.lang.String mergeTagSelectors, HasParentChildAttribute.ParentChildEnum parentChild)` This method is called while building the structural table instance.

    - ### Methods inherited from class com.ihr.xbrl.om.table.definition.XBRLRelationshipNode

      `getFormulaAxis, getLinkrole, staticCheck`

    - ### Methods inherited from class com.ihr.xbrl.om.table.definition.XBRLClosedDefinitionNode

      `allowRollUps, getParentChildOrder, isParentChildOrderDefined`

    - ### Methods inherited from class com.ihr.xbrl.om.table.definition.XBRLDefinitionNode

      `getBreakdownTree, getNumberOfNodes, getTagSelector, hasOpen, isLeaf, isOpen, readDefinitionNodeSubTree, resetTable`

    - ### Methods inherited from class com.ihr.xbrl.om.table.XBRLTableResource

      `getFPXPathCompiler, getProcessor, isSpecificationVersion`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `addChild, clear, equals, generateLocatorToNode, generateNode, getAttributes, getDTSBase, getFriendlyName, getFriendlyName, getParent, getResourceIdentifier, getRoleType, getType, getValidationReport, getValueKey, hashCode, invalidate, invalidate, isComplexType, isOnValidation, isSimpleType, setComplexType, setDTSBase, setId, setParent, setRole, setRoleType, setSimpleType, setValue, validate`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElements, getElementsHashCode, getFragment, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLRelationshipPoint

      `addFromRelationship, addToRelationship, getFromRelationships, getToRelationships, removeFromRelationship, removeToRelationship`

- - ### Constructor Detail

    - #### XBRLDimensionRelationshipNode

          public XBRLDimensionRelationshipNode(XBRLTableProcessor xbrlTableProcessor,
                                       XBRLResource res)
                                        throws XTValidationException

      Instantiates a new XBRL dimension relationship node.
      Parameters:
        `xbrlTableProcessor` - the xbrl table processor
        `res` - the res
      Throws:
        `XTValidationException` - the XT validation exception

  - ### Method Detail

    - #### getSources

          public javax.xml.namespace.QName[] getSources(XBRLStructuralTable xbrlTable)
                                                 throws XTValidationException

      Description copied from class: `XBRLRelationshipNode`
      Access to the resolved QName sources.
      Specified by:
        `getSources` in class `XBRLRelationshipNode`
      Parameters:
        `xbrlTable` - the xbrl table
      Returns:
        the sources
      Throws:
        `XTValidationException` - the XT validation exception

    - #### isAbstract

          public boolean isAbstract()

      Description copied from class: `XBRLDefinitionNode`
      Returns true if this is a closed definition node and is abstract.
      Specified by:
        `isAbstract` in class `XBRLDefinitionNode`
      Returns:
        boolean value

    - #### getDimension

          public javax.xml.namespace.QName getDimension()

      Access to the dimension QName for this node.
      Returns:
        the dimension

    - #### readDefinitionNodeSubTree

          public XBRLStructuralNode[] readDefinitionNodeSubTree(XBRLDefinitionNodeUse dnu,
                                                       XBRLStructuralTable xbrlTable,
                                                       java.util.Hashtable<java.lang.String,java.util.Hashtable<java.lang.Object,AspectAndDistanceToLeaf>> mergeAspects,
                                                       java.lang.String mergeTagSelectors,
                                                       HasParentChildAttribute.ParentChildEnum parentChild)
                                                         throws XTValidationException

      Description copied from class: `XBRLRelationshipNode`
      This method is called while building the structural table instance. It is required to process all incoming parameters and read the network.
      Specified by:
        `readDefinitionNodeSubTree` in class `XBRLRelationshipNode`
      Parameters:
        `dnu` - the dnu
        `xbrlTable` - the xbrl table
        `mergeAspects` - the merge aspects
        `mergeTagSelectors` - the merge tag selectors
        `parentChild` - the parent child
      Returns:
        the XBRL structural node[]
      Throws:
        `XTValidationException` - the XT validation exception

    - #### getGenerations

          public int getGenerations(XBRLStructuralTable xbrlTable,
                           RC_XFI_concept_relationshipsBase.Axis axis)
                             throws XTValidationException

      Description copied from class: `XBRLRelationshipNode`
      Access to the resolved generations parameter
      Specified by:
        `getGenerations` in class `XBRLRelationshipNode`
      Parameters:
        `xbrlTable` - the xbrl table
        `axis` - the axis
      Returns:
        the generations
      Throws:
        `XTValidationException` - the XT validation exception